﻿using System;
using System.Linq;
using System.Net;
using System.Net.Sockets;

// Inspired by http://www.codeincodeblock.com/2013/12/basic-udp-socket-echo-client-server.html
namespace UdpEchoServer
{
    public class Program
    {
        public const int Port = 7;

        static void Main()
        {
            using (UdpClient client = new UdpClient(Port))
            {
                IPEndPoint remoteEndPoint = new IPEndPoint(IPAddress.Loopback, 0);
                while (true)
                {
                    Console.WriteLine("UDP Echo server waiting on {0} port {1}", remoteEndPoint.Address, Port);
                    byte[] receiveBuffer = client.Receive(ref remoteEndPoint);
                    Console.WriteLine("Handling client at " + remoteEndPoint);
                    //echoes back the content of the receive buffer
                    client.Send(receiveBuffer, receiveBuffer.Length, remoteEndPoint);
                    Console.WriteLine("echoes {0}  bytes", receiveBuffer.Length);
                }
            }
        }
    }
}
